# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'ConnectivityType',
    'ContentType',
    'DataConnectorKind',
    'DataTypeState',
    'Kind',
    'Operator',
    'PermissionProviderScope',
    'PollingFrequency',
    'ProviderName',
    'RepoType',
    'SettingKind',
    'SettingType',
    'Source',
    'SourceKind',
    'SupportTier',
    'UebaDataSources',
]


class ConnectivityType(str, Enum):
    """
    type of connectivity
    """
    IS_CONNECTED_QUERY = "IsConnectedQuery"


class ContentType(str, Enum):
    """
    Content type.
    """
    ANALYTIC_RULE = "AnalyticRule"
    WORKBOOK = "Workbook"


class DataConnectorKind(str, Enum):
    """
    The data connector kind
    """
    AZURE_ACTIVE_DIRECTORY = "AzureActiveDirectory"
    AZURE_SECURITY_CENTER = "AzureSecurityCenter"
    MICROSOFT_CLOUD_APP_SECURITY = "MicrosoftCloudAppSecurity"
    THREAT_INTELLIGENCE = "ThreatIntelligence"
    THREAT_INTELLIGENCE_TAXII = "ThreatIntelligenceTaxii"
    OFFICE365 = "Office365"
    OFFICE_ATP = "OfficeATP"
    AMAZON_WEB_SERVICES_CLOUD_TRAIL = "AmazonWebServicesCloudTrail"
    AZURE_ADVANCED_THREAT_PROTECTION = "AzureAdvancedThreatProtection"
    MICROSOFT_DEFENDER_ADVANCED_THREAT_PROTECTION = "MicrosoftDefenderAdvancedThreatProtection"
    DYNAMICS365 = "Dynamics365"
    MICROSOFT_THREAT_PROTECTION = "MicrosoftThreatProtection"
    MICROSOFT_THREAT_INTELLIGENCE = "MicrosoftThreatIntelligence"
    GENERIC_UI = "GenericUI"


class DataTypeState(str, Enum):
    """
    Describe whether this data type connection is enabled or not.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


class Kind(str, Enum):
    """
    The kind of content the metadata is for.
    """
    DATA_CONNECTOR = "dataConnector"
    DATA_TYPE = "dataType"
    WORKBOOK = "workbook"
    WORKBOOK_TEMPLATE = "workbookTemplate"
    PLAYBOOK = "playbook"
    PLAYBOOK_TEMPLATE = "playbookTemplate"
    ANALYTIC_RULE_TEMPLATE = "analyticRuleTemplate"
    ANALYTIC_RULE = "analyticRule"
    HUNTING_QUERY = "huntingQuery"
    INVESTIGATION_QUERY = "investigationQuery"
    PARSER = "parser"
    WATCHLIST = "watchlist"
    WATCHLIST_TEMPLATE = "watchlistTemplate"
    SOLUTION = "solution"


class Operator(str, Enum):
    """
    Operator used for list of dependencies in criteria array.
    """
    AND_ = "AND"
    OR_ = "OR"


class PermissionProviderScope(str, Enum):
    """
    Permission provider scope
    """
    RESOURCE_GROUP = "ResourceGroup"
    SUBSCRIPTION = "Subscription"
    WORKSPACE = "Workspace"


class PollingFrequency(str, Enum):
    """
    The polling frequency for the TAXII server.
    """
    ONCE_A_MINUTE = "OnceAMinute"
    ONCE_AN_HOUR = "OnceAnHour"
    ONCE_A_DAY = "OnceADay"


class ProviderName(str, Enum):
    """
    Provider name
    """
    MICROSOFT_OPERATIONAL_INSIGHTS_SOLUTIONS = "Microsoft.OperationalInsights/solutions"
    MICROSOFT_OPERATIONAL_INSIGHTS_WORKSPACES = "Microsoft.OperationalInsights/workspaces"
    MICROSOFT_OPERATIONAL_INSIGHTS_WORKSPACES_DATASOURCES = "Microsoft.OperationalInsights/workspaces/datasources"
    MICROSOFT_AADIAM_DIAGNOSTIC_SETTINGS = "microsoft.aadiam/diagnosticSettings"
    MICROSOFT_OPERATIONAL_INSIGHTS_WORKSPACES_SHARED_KEYS = "Microsoft.OperationalInsights/workspaces/sharedKeys"
    MICROSOFT_AUTHORIZATION_POLICY_ASSIGNMENTS = "Microsoft.Authorization/policyAssignments"


class RepoType(str, Enum):
    """
    The repository type of the source control
    """
    GITHUB = "Github"
    DEV_OPS = "DevOps"


class SettingKind(str, Enum):
    """
    The kind of the setting
    """
    EYES_ON = "EyesOn"
    ENTITY_ANALYTICS = "EntityAnalytics"
    UEBA = "Ueba"


class SettingType(str, Enum):
    """
    The kind of the setting
    """
    COPYABLE_LABEL = "CopyableLabel"
    INSTRUCTION_STEPS_GROUP = "InstructionStepsGroup"
    INFO_MESSAGE = "InfoMessage"


class Source(str, Enum):
    """
    The source of the watchlist
    """
    LOCAL_FILE = "Local file"
    REMOTE_STORAGE = "Remote storage"


class SourceKind(str, Enum):
    """
    Source type of the content
    """
    LOCAL_WORKSPACE = "localWorkspace"
    COMMUNITY = "community"
    SOLUTION = "solution"
    SOURCE_REPOSITORY = "sourceRepository"


class SupportTier(str, Enum):
    """
    Type of support for content item
    """
    MICROSOFT = "microsoft"
    DEVELOPER = "developer"
    COMMUNITY = "community"


class UebaDataSources(str, Enum):
    """
    The data source that enriched by ueba.
    """
    AUDIT_LOGS = "AuditLogs"
    AZURE_ACTIVITY = "AzureActivity"
    SECURITY_EVENT = "SecurityEvent"
    SIGNIN_LOGS = "SigninLogs"
